#!/bin/bash

. compile_constants.sh

echo "###########################################################"
echo "# Compiling ShortCutSolver"
echo "###########################################################"


echo "# Common"

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/TCouplingHandler.o Common/TCouplingHandler.cpp 
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/TCouplingHandler.o Common/TCouplingHandler.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/TVarListHandler.o Common/TVarListHandler.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/TVarListHandler.o Common/TVarListHandler.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/THierarchicalPartition.o Common/THierarchicalPartition.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/THierarchicalPartition.o Common/THierarchicalPartition.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/THierarchicalPartitionInterface.o Common/THierarchicalPartitionInterface.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/THierarchicalPartitionInterface.o Common/THierarchicalPartitionInterface.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/tools.o Common/tools.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o Common/tools.o Common/tools.cpp


echo "# CostFunctionComputation"


echo $FLAGS_INCLUDE $FLAGS_MISC -c -o CostFunctionComputation/Release/CostFunctionComputation.o \
		CostFunctionComputation/CostFunctionComputation.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o CostFunctionComputation/Release/CostFunctionComputation.o \
		CostFunctionComputation/CostFunctionComputation.cpp
	
echo -shared -o CostFunctionComputation/Release/libCostFunctionComputation.so \
	CostFunctionComputation/Release/CostFunctionComputation.o \
	Common/THierarchicalPartition.o \
	Common/THierarchicalPartitionInterface.o \
	Common/TVarListHandler.o \
	$FLAGS_LINKER

$CC -shared -o CostFunctionComputation/Release/libCostFunctionComputation.so \
	CostFunctionComputation/Release/CostFunctionComputation.o \
	Common/THierarchicalPartition.o \
	Common/THierarchicalPartitionInterface.o \
	Common/TVarListHandler.o \
	$FLAGS_LINKER

echo "# ShortCutSolver"


echo $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShieldGenerator/TShieldGenerator.o \
	ShortCutSolver/ShieldGenerator/TShieldGenerator.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShieldGenerator/TShieldGenerator.o \
	ShortCutSolver/ShieldGenerator/TShieldGenerator.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/Interfaces.o ShortCutSolver/Interfaces.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/Interfaces.o ShortCutSolver/Interfaces.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShortCutSolver-Interface.o ShortCutSolver/ShortCutSolver-Interface.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShortCutSolver-Interface.o ShortCutSolver/ShortCutSolver-Interface.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShortCutSolver-Tools.o ShortCutSolver/ShortCutSolver-Tools.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/ShortCutSolver-Tools.o ShortCutSolver/ShortCutSolver-Tools.cpp

echo $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/TShortCutSolver.o ShortCutSolver/TShortCutSolver.cpp
$CC $FLAGS_INCLUDE $FLAGS_MISC -c -o ShortCutSolver/Release/TShortCutSolver.o ShortCutSolver/TShortCutSolver.cpp



echo -shared -o ShortCutSolver/Release/libShortCutSolver.so \
	ShortCutSolver/Release/ShieldGenerator/TShieldGenerator.o \
	ShortCutSolver/Release/Interfaces.o \
	ShortCutSolver/Release/ShortCutSolver-Interface.o \
	ShortCutSolver/Release/ShortCutSolver-Tools.o \
	ShortCutSolver/Release/TShortCutSolver.o \
	Common/THierarchicalPartition.o \
	Common/TCouplingHandler.o \
	Common/TVarListHandler.o \
	Common/tools.o \
	$FLAGS_LINKER


$CC -shared -o ShortCutSolver/Release/libShortCutSolver.so \
	ShortCutSolver/Release/ShieldGenerator/TShieldGenerator.o \
	ShortCutSolver/Release/Interfaces.o \
	ShortCutSolver/Release/ShortCutSolver-Interface.o \
	ShortCutSolver/Release/ShortCutSolver-Tools.o \
	ShortCutSolver/Release/TShortCutSolver.o \
	Common/THierarchicalPartition.o \
	Common/TCouplingHandler.o \
	Common/TVarListHandler.o \
	Common/tools.o \
	$FLAGS_LINKER


